#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include "config.h"
#include "tslib-private.h"

struct jz_ts_event {
	unsigned short status;
	unsigned short x;
	unsigned short y;
	unsigned short pressure;
	unsigned short pad;
};

static int jz_read(struct tslib_module_info *inf, struct ts_sample *samp, int nr)
{
	struct tsdev *ts = inf->dev;
	struct jz_ts_event *jz_evt;
	int ret;
	int total = 0;
	jz_evt = alloca(sizeof(*jz_evt) * nr);
	ret = read(ts->fd, jz_evt, sizeof(*jz_evt) * nr);
	if(ret > 0) {
		int nr = ret / sizeof(*jz_evt);
		while(ret >= (int)sizeof(*jz_evt)) {
			samp->x = jz_evt->x;
			samp->y = jz_evt->y;
			samp->pressure = jz_evt->pressure;
#ifdef DEBUG
        fprintf(stderr,"RAW---------------------------> %d %d %d\n",samp->x,samp->y,samp->pressure);
#endif /*DEBUG*/
			gettimeofday(&samp->tv,NULL);
			samp++;
			jz_evt++;
			ret -= sizeof(*jz_evt);
		}
	} else {
		return -1;
	}

	ret = nr;
	return ret;
}

static const struct tslib_ops jz_ops =
{
	.read	= jz_read,
};

TSAPI struct tslib_module_info *mod_init(struct tsdev *dev, const char *params)
{
	struct tslib_module_info *m;

	m = malloc(sizeof(struct tslib_module_info));
	if (m == NULL)
		return NULL;

	m->ops = &jz_ops;
	return m;
}
